<script setup>
import AppLayout from '@/Layouts/AppLayoutWater.vue';
import Welcome from '@/Jetstream/Welcome.vue';
import Datepicker from '@vuepic/vue-datepicker';
import JetDropdown from '@/Jetstream/Dropdown.vue';
import JetDropdownLink from '@/Jetstream/DropdownLink.vue';
import '@vuepic/vue-datepicker/dist/main.css';
import { startOfDay, endOfDay, subDays, endOfMonth, endOfYear, startOfMonth, startOfYear, subMonths } from 'date-fns';
import Highcharts from 'highcharts';
import { Link } from '@inertiajs/inertia-vue3';
import DK_Button from '@/components/dk_Button.vue';
import Dk_Notification from '../components/dk_Notification.vue';

var alerts = 0;
</script>
<style>

table {
    border-color: transparent !important;
}

.dataTables_wrapper {
    margin-bottom: 0.5rem !important;
}

table.dataTable thead th,
table.dataTable thead td {
    padding: 5px 10px;
    font-size: 0.9rem !important;
    border-bottom: 1px solid rgba(200, 200, 200, 0.75) !important;
}

.dataTables_wrapper .dataTables_paginate .paginate_button.disabled,
.dataTables_wrapper .dataTables_paginate .paginate_button.disabled:hover,
.dataTables_wrapper .dataTables_paginate .paginate_button.disabled:active {
    cursor: default;
    color: rgba(200, 200, 200, 0.9) !important;
    border: 1px solid transparent;
    background: transparent;
    box-shadow: none;
}

.dataTables_wrapper .dataTables_paginate .paginate_button {
    box-sizing: border-box;
    display: inline-block;
    min-width: 1.5em;
    padding: 0.5em 1em;
    margin-left: 2px;
    text-align: center;
    text-decoration: none !important;
    cursor: pointer;
    cursor: hand;
    color: rgba(200, 200, 200, 0.9) !important;
    border: 0;
    border-radius: 0.375rem;
}

.dataTables_wrapper .dataTables_paginate .paginate_button:hover {
    color: rgba(200, 200, 200, 1) !important;
    background-color: rgba(0, 152, 219, 0.1) !important;
    background-image: unset !important;
    border: 0;
}

.dataTables_wrapper .dataTables_paginate .paginate_button.current,
.dataTables_wrapper .dataTables_paginate .paginate_button.current:hover {
    color: rgba(255, 250, 250, 1) !important;
    border: 0 !important;
    background-color: rgba(0, 152, 219, 0.2) !important;
    background-image: unset !important;
    border-bottom-width: 2px;
    border-bottom-color: rgba(255, 250, 250, 1);
    border-radius: 0.375rem;
}

div.dt-buttons {
    float: right;
    margin-bottom: 1rem;
}

.dp__theme_light {
    --dp-background-color: rgba(0, 57, 93, 0.95);
    --dp-text-color: #e3e3e3;
    --dp-hover-color: rgba(0, 255, 255, 0.2);
    --dp-hover-text-color: #FFFAFA;
    --dp-hover-icon-color: #e3e3e3;
    --dp-primary-color: rgba(0, 255, 255, 0.5);
    --dp-primary-text-color: #FFFAFA;
    --dp-secondary-color: #959595;
    --dp-border-color: #FFFAFA;
    --dp-menu-border-color: #FFFAFA;
    --dp-border-color-hover: #FFFAFA;
    --dp-disabled-color: #959595;
    --dp-scroll-bar-background: #f3f3f3;
    --dp-scroll-bar-color: #959595;
    --dp-success-color: rgba(5, 255, 243, 0.7);
    --dp-success-color-disabled: rgba(5, 255, 243, 0.7);
    --dp-icon-color: #e3e3e3;
    --dp-danger-color: #e6002e;
    --dp-highlight-color: rgba(25, 118, 210, 0.1);
}

.dp__preset_range {
    color: #e3e3e3;
}

.dp__action {
    font-weight: 400;
    font-size: x-large;
}

.dp__button {
    background: none;
}

.dp__action_row {
    border-radius: 0.5rem;
    background: none;
    padding-top: 0;
    display: flex;
    justify-content: flex-end;
}

.dp__menu_index {
    border-radius: 0.5rem;
}

.dp__cancel {
    display: none;
    color: #e6002e;
}

.dp__selection_preview {
    display: none;
}

.dp__input_reg {
    background: none;
    border-width: 1px;
    border-color: rgba(200, 200, 200, 0.9);
    border-radius: 0.5rem;

}

.dp__input {
    font-size: 0.95rem;
}

.dp__pointer {
    padding-top: 0.25rem;
    padding-bottom: 0.25rem;
}

.dp__arrow_top {
    display: none;
}
</style>

<template>
    <AppLayout title="Readings">
        <loader-component></loader-component>
        <div v-if="this.screen_width >= 768" style="height: calc(100vh - 4.75rem);" class="bg-darkblue-background -z-1 overflow-y-scroll cursor-default select-none">
            <!-- TIME INTERVAL SELECTOR -->
            <div class="mx-4 text-xs text-center text-gray-light flex justify-between">
                <div class="flex flex-col justify-start items-start w-full">
                    <div class="justify-between self-center items-baseline flex w-full pt-2"> <!--id="routeprofile"-->
                        <div class="flex items-start ">
                            <p class="text-white-snow font-light text-2xl w-full text-left">{{ this.name }}&nbsp;(Id:&nbsp;{{ this.id }})</p>                   
                            <i class="fa-solid fa-circle-info self-center ml-2" @mouseleave="hover_info = false"
                                @mouseover="hover_info = true"></i>         
                            <div v-bind:class="{'invisible' : !hover_info }"
                                class="flex justify-center items-center px-2 py-1 gap-x-4 rounded-md border border-gray-light ml-2">
                                <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base">
                                    <p :style="{ 'background-color': this.Service_color }" class="service-label">
                                        {{ this.Service_tag }}
                                    </p>
                                </div>

                                <!--<p class="text-2xl">&nbsp;/ {{JSON.parse(this.Sector)[0]['name']}}</p>-->
                                <!--<p class="text-2xl">&nbsp;/&nbsp;</p>-->

                                <!--<div v-for="(data, index) in this.Sector" :key="index" class="inline-flex">
                                        <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base	">
                                            <p class="sector-label">
                                                {{data["name"]}}
                                            </p>
                                        </div>
                                    </div>-->
                                <div class="inline-flex gap-x-2">
                                    <div v-for="(data_s, index_s) in this.Sector" :key="index_s" class="inline-flex">
                                        <div v-for="(data_g, index_g) in this.data.device.group_sector" :key="index_g"
                                            class="inline-flex rounded-md  text-white-snow font-light text-base">
                                            <p v-if="index_s == this.data.device.group_sector[index_g].id" class="sector-label">
                                                {{ data_g.tag }}
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="flex gap-2 items-end mt-0">
                            <div class="flex items-start justify-end">
                                <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('meterProfile', { id:  this.id })" >
                                    <DK_Button color="blue" :fixedSize="true">
                                        {{ this.$t("general.Profile") }}
                                    </DK_Button>
                                </Link>
                            </div>
                            <div class="flex items-start justify-end">
                                <DK_Button class="pt-6" color="blue" :fixedSize="true" onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit'); window.history.go(-1)">
                                    {{ this.$t("general.Back") }}
                                </DK_Button>
                            </div>
                        </div>
                        <!--<p v-bind:class='{ "bg-Pressure-TAG": this.Service_name == "pressureLang","bg-Water-quality-TAG": this.Service_name == "waterQualityLang","bg-Deposit-levels-TAG": this.Service_name == "waterLevelLang", "bg-Distribution-TAG": this.Service_name == "distributionLang", "bg-Domiciliary-TAG": this.Service_name == "domiciliaryLang" }' class="rounded-md shadow-lg px-1 text-md">
                                {{this.Service_name.substring(0, 3).toUpperCase()}}
                            </p> -->
                    </div>
                    <div class="inline-flex justify-center items-end gap-x-4 hidden">
                        <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base">
                            <p :style="{ 'background-color': this.Service_color }" class="service-label">
                                {{ this.Service_tag }}
                            </p>
                        </div>

                        <!--<p class="text-2xl">&nbsp;/ {{JSON.parse(this.Sector)[0]['name']}}</p>-->
                        <!--<p class="text-2xl">&nbsp;/&nbsp;</p>-->

                        <!--<div v-for="(data, index) in this.Sector" :key="index" class="inline-flex">
                                <div class="inline-flex justify-end rounded-md  text-white-snow font-light text-base	">
                                    <p class="sector-label">
                                        {{data["name"]}}
                                    </p>
                                </div>
                            </div>-->
                        <div class="inline-flex gap-x-2">
                            <div v-for="(data_s, index_s) in this.Sector" :key="index_s" class="inline-flex">
                                <div v-for="(data_g, index_g) in this.data.device.group_sector" :key="index_g"
                                    class="inline-flex rounded-md  text-white-snow font-light text-base">
                                    <p v-if="index_s == this.data.device.group_sector[index_g].id" class="sector-label">
                                        {{ data_g.tag }}
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!--<p id="routeprofile" class="text-xs text-gray-medium font-light">Id: {{this.id}}</p>-->
                    <div class="mt-4 inline-flex gap-6">

                        <Datepicker id="interval_date" class="w-[21rem] justify-self-end self-end" v-model="date" vertical
                            :presetRanges="this.presetRanges" range @update:modelValue="update" :clearable="false"
                            :format="this.format"></Datepicker>

                        <div class="border border-gray-semilight rounded-lg flex flex-row cursor-pointer">
                            <div class="time-link-active rounded-l-lg">
                                {{ this.$t("general." + "Hour") }}
                            </div>
                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('Water_DayData', { id: this.id })">
                                <div class="time-link rounded-l-lg">
                                    {{ this.$t("general." + "Day") }}
                                </div>
                            </Link>
                        </div>

                    </div>

                    <div v-bind:class="{ 'hidden': this.register_length !=0}" class="flex gap-2 whitespace-nowrap items-baseline mt-4">
                        <i class="fa-solid fa-triangle-exclamation" style="font-size:0.8rem; color:rgba(224,191,52,1);"></i>
                        <p class="font-light text-sm text-white-snow flex whitespace-nowrap">
                            {{ this.$t('text.No records were found for the device') }}
                        </p>
                    </div>
                </div>
            </div>

            <div class="grid 2xl:grid-cols-8 grid-cols-6 gap-x-6 px-4">

            <!--<div class="col-span-8 flex justify-center">
                    <Datepicker id="interval_date" v-model="date" vertical :presetRanges="this.presetRanges" range @update:modelValue="update" :clearable="false" :flow="['date','time']" :format="this.format"></Datepicker>
                </div>-->

            <div v-if="data.pressure"
                class="2xl:col-span-7 col-span-5 grid grid-cols-8 gap-6 mt-6 h-[25rem] baltoro-container">

                <!-- PRESSURE & PRESSURE VARIATIONS CHART -->
                <div class="col-span-8 px-10 pt-4">
                    <p class="text-white-snow font-light text-2xl mb-4">{{ this.$t("text." + "Pressure variation at each interval")}}</p>
                    <div class="h-[22rem] cursor-crosshair pb-4" id='pressurechart'></div>
                </div>

            </div>

                <!-- PRESSURE SIDEMENU -->

            <div v-if="data.pressure" class="col-span-1 grid content-between text-center text-white-snow text-xs  mt-6">

                <div class="m-0 p-0 baltoro-container py-1">
                    <p class="text-cyan-text font-normal py-1">{{ this.$t("water." + "maxAmpLang") }}</p>
                    <div class="w-full inline-flex justify-center items-end">
                        <p class="text-3xl font-sevensegment">
                            {{ this.maxAmp }}
                        </p>
                        <p class="pb-1"> &nbsp;bar</p>
                    </div>
                </div>

                <div class="m-0 gap-2 grid text-center baltoro-container py-1">

                    <p class="col-span-2 text-cyan-text font-normal py-1">{{ this.$t("water." + "resPreLang") }}</p>

                    <div class="col-span-2 contents">
                        <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                        <div class="inline-flex justify-center items-end">
                            <p class="text-2xl font-sevensegment self-center">
                                {{ this.pressureMax.toFixed(3) }}
                            </p>
                            <p class="pb-1"> &nbsp;bar</p>
                        </div>
                    </div>

                    <div class="col-span-2 contents">
                        <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                        <div class="inline-flex justify-center items-end">
                            <p class="text-2xl font-sevensegment self-center">
                                {{ this.pressureAvg.toFixed(3) }}
                            </p>
                            <p class="pb-1"> &nbsp;bar</p>
                        </div>
                    </div>

                    <div class="col-span-2 contents">
                        <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                        <div class="inline-flex justify-center items-end">
                            <p class="text-2xl font-sevensegment self-center">
                                {{ this.pressureMin.toFixed(3) }}
                            </p>
                            <p class="pb-1"> &nbsp;bar</p>
                        </div>
                    </div>

                </div>

                <div class="m-0 gap-2 grid text-center baltoro-container py-1">

                    <p class="col-span-2 text-cyan-text font-normal py-1">{{ this.$t("water." + "pressureDispersionLang") }}
                    </p>

                    <div class="col-span-2 contents">
                        <p class="self-center">{{ this.$t("general." + "Q3") }}</p>
                        <div class="inline-flex justify-center items-end">
                            <p class="text-2xl font-sevensegment self-center">
                                {{ this.Q3 }}
                            </p>
                            <p class="pb-1"> &nbsp;bar</p>
                        </div>
                    </div>

                    <div class="col-span-2 contents">
                        <p class="self-center">{{ this.$t("general." + "Med") }}</p>
                        <div class="inline-flex justify-center items-end">
                            <p class="text-2xl font-sevensegment self-center">
                                {{ this.Q2 }}
                            </p>
                            <p class="pb-1"> &nbsp;bar</p>
                        </div>
                    </div>

                    <div class="col-span-2 contents">
                        <p class="self-center">{{ this.$t("general." + "Q1") }}</p>
                        <div class="inline-flex justify-center items-end">
                            <p class="text-2xl font-sevensegment self-center">
                                {{ this.Q1 }}
                            </p>
                            <p class="pb-1"> &nbsp;bar</p>
                        </div>
                    </div>

                </div>

            </div>

                <!--<div class="col-span-1 text-center text-white-snow mt-6 text-xs grid content-between">
                    
                        <div class="m-0 p-0 baltoro-container py-1">
                            <p class="text-cyan-text font-normal py-1">Maximum</p>
                            <div class="w-full">
                                <p class="text-3xl font-sevensegment">
                                    {{this.pressureMax.toFixed(3)}}
                                </p>
                                <p class="pb-1"> &nbsp;bar</p>
                            </div>
                        </div>

                        <div class="m-0 p-0 baltoro-container py-1">
                            <p class="text-cyan-text font-normal py-1">Quartile 75%</p>
                            <div class="w-full">
                                <p class="text-3xl font-sevensegment">
                                    {{this.Q3}}
                                </p>
                                <p class="pb-1"> &nbsp;bar</p>
                            </div>
                        </div>

                        <div class="m-0 p-0 baltoro-container py-1">
                            <p class="text-cyan-text text-xs font-normal py-1">Median</p>
                            <div class="w-full">
                                <p class="text-3xl font-sevensegment">
                                    {{this.Q2}}
                                </p>
                                <p class="pb-1"> &nbsp;bar</p>
                            </div>
                        </div>-->

                <!--<div class="m-0 p-0 baltoro-container py-1">
                            <p class="text-cyan-text font-normal py-1">Average</p>
                            <div class="w-full">
                                <p class="text-3xl font-sevensegment">
                                    {{this.pressureAvg.toFixed(3)}}
                                </p>
                                <p class="pb-1"> &nbsp;bar</p>
                            </div>
                        </div>

                        <div class="grid grid-cols-2 gap-x-6 m-0 p-0">
                            <div class="shadow-lg col-span-1 rounded-md bg-darkblue-opa-container py-1">
                                <p class="text-cyan-text font-normal py-1">Average</p>
                                <div class="w-full">
                                    <p class="text-3xl font-sevensegment">
                                        {{this.pressureAvg.toFixed(3)}}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>
                            <div class="shadow-lg col-span-1 rounded-md bg-darkblue-opa-container py-1">
                                <p class="text-cyan-text font-normal py-1">Median</p>
                                <div class="w-full">
                                    <p class="text-3xl font-sevensegment">
                                        {{this.Q2}}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>
                        </div>-->

                <!--<div class="m-0 p-0 baltoro-container py-1">
                            <p class="text-cyan-text font-normal py-1">Quartile 25%</p>
                            <div class="w-full">
                                <p class="text-3xl font-sevensegment">
                                    {{this.Q1}}
                                </p>
                                <p class="pb-1"> &nbsp;bar</p>
                            </div>
                        </div>

                        <div class="m-0 p-0 baltoro-container py-1">
                            <p class="text-cyan-text font-normal py-1">Minimum</p>
                            <div class="w-full">
                                <p class="text-3xl font-sevensegment">
                                    {{this.pressureMin.toFixed(3)}}
                                </p>
                                <p class="pb-1"> &nbsp;bar</p>
                            </div>
                        </div>  
                    
                    </div>-->

                <div class="2xl:col-span-7 col-span-5 grid grid-cols-8 gap-6 baltoro-container h-[25rem] mt-6">

                    <!-- FLOW & FLOW VARIATIONS CHART -->
                    <div class="col-span-8 px-10 pt-4">
                        <p class="text-white-snow font-light text-2xl mb-4">{{ this.$t("text." + "Flow and consumption variation") }}
                        </p>
                        <div class="h-[22rem] cursor-crosshair pb-4" id='flowchart'></div>
                    </div>

                </div>
                <!-- FLOW SIDEMENU -->
                <div class="col-span-1 grid content-between text-center text-white-snow text-xs  mt-6">

                    <div class="m-0 p-0 baltoro-container py-1">
                        <p class="text-cyan-text font-normal py-1">{{ this.$t("water." + "consumptionLang") }}</p>
                        <div class="w-full inline-flex justify-center items-end">
                            <p class="text-3xl font-sevensegment">
                                {{ this.totalconsumption.toFixed(3) }}
                            </p>
                            <p class="pb-1"> &nbsp;m³</p>
                        </div>
                    </div>

                    <div class="m-0 gap-2 grid text-center baltoro-container rounded-md py-1">

                        <p class="col-span-2 text-cyan-text font-normal py-1">{{ this.$t("water." + "consumptionDataLang") }}
                        </p>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.consumptionMax.toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.consumptionAvg.toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.consumptionMin.toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³</p>
                            </div>
                        </div>

                    </div>

                    <div class="m-0 gap-2 grid text-center baltoro-container py-1">

                        <p class="col-span-2 text-cyan-text font-normal py-1">{{ this.$t("water." + "flowDataLang") }}</p>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.flowMax.toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³/h</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.flowAvg.toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³/h</p>
                            </div>
                        </div>

                        <div class="col-span-2 contents">
                            <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                            <div class="inline-flex justify-center items-end">
                                <p class="text-2xl font-sevensegment self-center">
                                    {{ this.flowMin.toFixed(3) }}
                                </p>
                                <p class="pb-1"> &nbsp;m³/h</p>
                            </div>
                        </div>

                    </div>

                </div>

                <div class="2xl:col-span-8 col-span-6 pt-5 mb-6 px-10 baltoro-container mt-6 ">
                    <p class="text-white-snow font-light text-2xl">{{ this.$t("text." + "Detailed readings") }}</p>
                    <table id="basicTable" class="row-border">
                        <thead class="bg-transparent text-gray-light">
                            <tr>
                                <th>{{ this.$t("general." + "Date") }}</th>
                                <th>{{ this.$t("general." + "Period") }}</th>
                                <th>{{ this.$t("water." + "consumptionLang") }} (m3)</th>
                                <th>{{ this.$t("water." + "flowLang") }} (m3/h)</th>
                                <th v-if="data.pressure">{{ this.$t("general." + "Min") }} (bar)</th>
                                <th v-if="data.pressure">{{ this.$t("general." + "Avg") }} (bar)</th>
                                <th v-if="data.pressure">{{ this.$t("general." + "Max") }} (bar)</th>
                                <th v-if="data.pressure">{{ this.$t("general." + "Amplitude") }} (bar)</th>
                            </tr>
                        </thead>
                        <tbody class="text-center">

                        </tbody>
                    </table>
                </div>
            </div>
        </div>

        <div v-else style="height: calc(100vh - 4.75rem);" class="bg-darkblue-background -z-1 cursor-default select-none overflow-x-hidden">

            <div class="w-full flex flex-col justify-center items-start pt-2 pb-1 gap-2">

                <div class="w-full flex flex-row justify-between px-3">
                    <div class="w-full flex flex-col justify-start">
                        <div class="flex flex-row justify-start">
                            <p class="text-white-snow font-light text-2xl text-left">{{ this.name }}</p>
                        </div>
                        <p class="text-white-snow font-light text-sm text-left">{{ this.id }}</p>                  
                    </div>
                    <div class="flex justify-end gap-2">
                        <div class="flex items-center justify-center">
                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit')" :href="route('meterProfile', { id:  this.id })" >
                                <button type="button" class="text-white-snow button-blue font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center">
                                    <i class="fa-solid fa-gears" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                </button>
                            </Link>
                        </div>
                        <div class="flex items-center justify-center">
                            <Link onclick="window.emitter.emit('changeLoaderStatus', true, 'orbit'); window.history.go(-1)">
                                <button type="button" class="text-white-snow button-blue font-medium rounded-lg text-sm p-1.5 text-center inline-flex items-center">
                                    <i class="fa-solid fa-arrow-left" style="font-size:0.75rem; color:#FFFAFA;"></i>
                                </button>
                            </Link>
                        </div>
                    </div>
                </div> 

                <div class="w-full px-3">
                    <Datepicker id="interval_date" class="w-full justify-self-end self-end" v-model="date" vertical
                            :presetRanges="this.presetRanges" range @update:modelValue="update" :clearable="false"
                            :format="this.format"></Datepicker>
                </div>

                <div v-bind:class="{ 'hidden': this.register_length !=0}" class="flex gap-1.5 whitespace-nowrap items-baseline w-full justify-center px-3">
                    <i class="fa-solid fa-triangle-exclamation" style="font-size:0.8rem; color:rgba(224,191,52,1);"></i>
                    <p class="font-light text-sm text-white-snow flex whitespace-nowrap">
                        {{ this.$t('text.No records were found for the device') }}
                    </p>
                </div>

                <div class="w-full flex overflow-x-auto snap-mandatory snap-x pb-2 gap-3 px-3">

                    <div v-if="data.pressure" class="snap-center shrink-0 flex flex-col snap-always gap-2 w-full">

                        <div class="p-2 baltoro-container w-full">
                            <p class="text-white-snow font-light text-lg mb-2 whitespace-nowrap w-full text-center">{{ this.$t("text." + "Pressure variation at each interval")}}</p>
                            <div class="h-[12rem] cursor-crosshair" id='pressurechart'></div>
                        </div>

                        <div class="p-2 baltoro-container w-full flex flex-row justify-between items-center">
                            <p class="text-cyan-text font-light text-md whitespace-nowrap w-full text-center">{{ this.$t("water." + "maxAmpLang") }}</p>
                            <div class="w-full inline-flex justify-center items-end text-gray-light">
                                <p class="text-2xl font-sevensegment">
                                    {{ this.maxAmp }}
                                </p>
                                <p class="pb-0.5"> &nbsp;bar</p>
                            </div>
                        </div>

                        <div class="grid text-center baltoro-container text-gray-light">

                            <p class="col-span-2 text-cyan-text font-light text-md whitespace-nowrap w-full text-center py-1">{{ this.$t("water." + "resPreLang") }}</p>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.pressureMax.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.pressureAvg.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.pressureMin.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>

                        </div>

                        <div class="grid text-center baltoro-container text-gray-light">

                            <p class="col-span-2 text-cyan-text font-light text-md whitespace-nowrap w-full text-center py-1">{{ this.$t("water." + "pressureDispersionLang") }}</p>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Q3") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.Q3 }}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Med") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.Q2 }}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Q1") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.Q1 }}
                                    </p>
                                    <p class="pb-1"> &nbsp;bar</p>
                                </div>
                            </div>
                        </div>

                        <div class="p-3 baltoro-container">
                            
                            <table id="basicTable_press" class="row-border">
                                <thead class="bg-transparent text-gray-light">
                                    <tr>
                                        <th>{{ this.$t("general." + "Date") }}</th>
                                        <th>{{ this.$t("general." + "Min") }} (bar)</th>
                                        <th>{{ this.$t("general." + "Avg") }} (bar)</th>
                                        <th>{{ this.$t("general." + "Max") }} (bar)</th>
                                        
                                    </tr>
                                </thead>
                                <tbody class="text-center">

                                </tbody>
                            </table>
                        </div>

                    </div>

                    <div class="snap-center shrink-0 flex flex-col snap-always gap-2 w-full">

                        <div class="p-2 baltoro-container w-full">
                            <p class="text-white-snow font-light text-lg mb-2 whitespace-nowrap w-full text-center">{{ this.$t("text." + "Flow and consumption variation")}}</p>
                            <div class="h-[12rem] cursor-crosshair" id='flowchart'></div>
                        </div>

                        <div class="p-2 baltoro-container w-full flex flex-row justify-between items-center">
                            <p class="text-cyan-text font-light text-md whitespace-nowrap w-full text-center">{{ this.$t("water." + "consumptionLang") }}</p>
                            <div class="w-full inline-flex justify-center items-end text-gray-light">
                                <p class="text-2xl font-sevensegment">
                                    {{ this.totalconsumption.toFixed(3) }}
                                </p>
                                <p class="pb-0.5"> &nbsp;m³</p>
                            </div>
                        </div>

                        <div class="grid text-center baltoro-container text-gray-light">

                            <p class="col-span-2 text-cyan-text font-light text-md whitespace-nowrap w-full text-center py-1">{{ this.$t("water." + "consumptionDataLang") }}</p>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.consumptionMax.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;m³</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.consumptionAvg.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;m³</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.consumptionMin.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;m³</p>
                                </div>
                            </div>

                        </div>

                        <div class="grid text-center baltoro-container text-gray-light">

                            <p class="col-span-2 text-cyan-text font-light text-md whitespace-nowrap w-full text-center py-1">{{ this.$t("water." + "flowDataLang") }}</p>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Max") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.flowMax.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;m³/h</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Avg") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.flowAvg.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;m³/h</p>
                                </div>
                            </div>

                            <div class="col-span-2 contents">
                                <p class="self-center">{{ this.$t("general." + "Min") }}</p>
                                <div class="inline-flex justify-center items-end">
                                    <p class="text-2xl font-sevensegment self-center">
                                        {{ this.flowMin.toFixed(3) }}
                                    </p>
                                    <p class="pb-1"> &nbsp;m³/h</p>
                                </div>
                            </div>

                        </div>

                        <div class="p-3 baltoro-container">
                            
                            <table id="basicTable_flow" class="row-border">
                                <thead class="bg-transparent text-gray-light">
                                    <tr>
                                        <th>{{ this.$t("general." + "Date") }}</th>
                                        <th>{{ this.$t("water." + "consumptionLang") }} (m3)</th>
                                        <th>{{ this.$t("water." + "flowLang") }} (m3/h)</th>
                                    </tr>
                                </thead>
                                <tbody class="text-center">

                                </tbody>
                            </table>
                        </div>

                    </div>

                </div>

            </div>
        </div>
    </AppLayout>
</template>

<script>
export default {
    props: ['data', 'user'],

    data() {
        return {
            Back: localStorage.getItem("Back"),
            screen_width: 0,
            register_length: (this.data.pulse) ? this.data.pulse[2].length : 0, 
            datehour: new Array(this.register_length),
            dateday: new Array(this.register_length),
            xdate: new Array(this.register_length),
            //night_start: 0,
            //night_end: 0,
            intervalConsumption24h_15: new Array(this.register_length),
            flowperHour24h_15: new Array(this.register_length),
            consumptionMin: 0,
            consumptionMax: 0,
            consumptionAvg: 0,
            totalconsumption: 0,
            flowMin: 0,
            flowMax: 0,
            flowAvg: 0,
            totalflow: 0,
            pressureMin: 0,
            pressureMax: 0,
            pressureAvg: 0,
            sumpressure: 0,
            name: this.data.device.name,
            Service_name: this.data.device.Service,
            Service_color: this.data.device.Service_color,
            Service_tag: this.data.device.Service_tag,
            Sector: this.data.device.Sector,
            id: this.data.device.id,
            pressuredata24h_15_avg: 0,
            pressuredata24h_15_min: 0,
            pressuredata24h_15_max: 0,
            //pressuredata24h_15_inst: 0,
            upper_limit: new Date(),
            end_date: new Date(),
            start_date: new Date(),
            date: null,
            hover_info: false,
            /*format: (date) => {
                const day = date.getDate();
                const month = date.getMonth() + 1;
                const year = date.getFullYear();

                return `Selected date is ${day}/${month}/${year}`;
            },*/
            table: null,
            Q1: null,
            Q2: null,
            Q3: null,
            maxAmp: null,
            amplitud: null,
            /* const endDate = new Date();

            var startDate = new Date(endDate);

            startDate.setDate(startDate.getDate() - 1);

            if(timeinterval=='month'){
                startDate.setMonth(startDate.getMonth()-1);
                startDate.setDate(startDate.getDate() +1);
            }else if(timeinterval=='week'){
                startDate.setDate(startDate.getDate() - 6);
            }
            this.update([startDate, endDate]); */
            /*format : (date) => {
                const day = date.getDate();
                const month = date.getMonth() + 1;
                const year = date.getFullYear();

                return `Selected date is ${day}/${month}/${year}`;
            }, */

            presetRanges: [
                { label: this.$t("general." + "Today"), range: [startOfDay(new Date()), new Date()] },
                { label: this.$t("general." + "Yesterday"), range: [startOfDay(subDays(new Date(), 1)), endOfDay(subDays(new Date(), 1))] },
                { label: this.$t("general." + "Last 7 Days"), range: [new Date().setDate(new Date().getDate() - 7), new Date().setDate(new Date().getDate())] },
                { label: this.$t("general." + "Last 14 Days"), range: [new Date().setDate(new Date().getDate() - 14), new Date().setDate(new Date().getDate())] },
                { label: this.$t("general." + "Last 30 Days"), range: [new Date().setDate(new Date().getDate() - 30), new Date().setDate(new Date().getDate())] },
                { label: this.$t("general." + "This month"), range: [startOfMonth(new Date()), new Date()] },
                { label: this.$t("general." + "Last month"), range: [startOfMonth(subMonths(new Date(), 1)), endOfMonth(subMonths(new Date(), 1))] }
            ],
            /*handleDate: (modelData) => {
                // do something else with the data
            },*/
            getLastDayFlow: (end_date, start_date) => {

                var end_event = new Date(end_date);

                end_event.setDate(end_event.getDate());
                end_event.setMonth(end_event.getMonth());
                //end_event.setHours(end_event.getHours());

                var MM = end_event.getMonth() + 1;
                var dd = end_event.getDate();
                var hh = end_event.getHours();
                var mm = end_event.getMinutes();
                var ss = end_event.getSeconds();

                if (MM.toString().length == 1) MM = '0' + MM;
                if (dd.toString().length == 1) dd = '0' + dd;
                if (hh.toString().length == 1) hh = '0' + hh;
                if (mm.toString().length == 1) mm = '0' + mm;
                if (ss.toString().length == 1) ss = '0' + ss;

                const end_date_format = end_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

                var start_event = new Date(start_date);

                start_event.setDate(start_event.getDate());
                start_event.setMonth(start_event.getMonth());
                //start_event.setHours(start_event.getHours());

                var MM = start_event.getMonth() + 1;
                var dd = start_event.getDate();
                var hh = start_event.getHours();
                var mm = start_event.getMinutes();
                var ss = start_event.getSeconds();

                if (MM.toString().length == 1) MM = '0' + MM;
                if (dd.toString().length == 1) dd = '0' + dd;
                if (hh.toString().length == 1) hh = '0' + hh;
                if (mm.toString().length == 1) mm = '0' + mm;
                if (ss.toString().length == 1) ss = '0' + ss;

                const start_date_format = start_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

                /*return axios
                .get('../api/gateway/data_summary/'+ this.id +'/0/0/' + start_date_format + '/' + end_date_format + '/' + this.user.token + '/' + this.user.timezone_offset)
                .then(response =>{
                    return response;
                })
                .catch(function(error) {
                    return ("Failed!", error);
                }); */
                window.emitter.emit('changeLoaderStatus', true, 'orbit')

                return axios({
                    method: 'get',
                    url: window.location.origin + '/api/gateway/data_summary/' + this.id + '/0/0/' + start_date_format + '/' + end_date_format + '/' + this.user.id + '/' + this.user.timezone_offset,
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                        'Authorization': 'Bearer ' + this.user.token
                    },
                })
                    .then((response) => {
                        window.emitter.emit('changeLoaderStatus', false, 'orbit')
                        return response;
                    })
                    .catch((error) => {
                        window.emitter.emit('changeLoaderStatus', false, 'orbit')

                        if(error.response && error.response.status && error.response.status == 429){
                        window.alert( this.$t('text.Api attempts'));
                        }else{
                        return "Failed!", error;
                        }

                    });
            },
        }
    },

    beforeCreate: function () {
        this.$i18n.locale = this.user.language
    },

    beforeMount(){
        this.screen_width = window.screen.width;
    },

    mounted() {

        window.emitter.emit('changeLoaderStatus', false, 'orbit')

        let user = this.user;

        if (this.data.pressure) {
            this.pressuredata24h_15_avg = new Array(this.data.pressure.length);
            this.pressuredata24h_15_min = new Array(this.data.pressure.length);
            this.pressuredata24h_15_max = new Array(this.data.pressure.length);
        }

        let today = new Date()
        let date = today.getFullYear() + '-' + (today.getMonth() + 1) + '-' + today.getDate()
        let time = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds()
        var export_title = this.name + '_' + this.id + '_' + date + '_' + time

        if(this.screen_width >= 768){

            this.table = $('#basicTable').DataTable({
                language: {
                    url: '/assets/i18n/' + this.user.language + '.json'
                },
                order: [[0, "desc"]],
                dom: '<"row"<"col-sm-6"B><"col-sm-6">>t<"row"<"col-sm-6"i><"col-sm-6"p>><"clear">',
                ordering: true,
                pageLength: 10,
                buttons: [
                    {
                        extend: 'csv',
                        text: 'CSV',
                        title: export_title,
                        className: 'btn btn-brand',
                        exportOptions: {
                            columns: ':visible'
                        }
                    },
                    {
                        extend: 'excel',
                        text: 'Excel',
                        title: export_title,
                        className: 'btn btn-brand',
                        exportOptions: {
                            columns: ':visible'
                        }
                    },
                    {
                        extend: 'print',
                        text: this.$t("general." + "Print"),
                        title: export_title,
                        className: 'btn btn-brand',
                        exportOptions: {
                            columns: ':visible'
                        }
                    },
                ]
            });

        }else{

            this.table = new Array(2);

            this.table[0] = $('#basicTable_flow').DataTable({
                language: {
                    url: '/assets/i18n/' + this.user.language + '.json'
                },
                order: [[0, "desc"]],
                dom: '<"row"<"col-sm-6"B><"col-sm-6">>t<"row"<"col-sm-6"i><"col-sm-6"p>><"clear">',
                ordering: true,
                pageLength: 10,
                responsive: true,
                buttons: [
                    {
                        extend: 'csv',
                        text: 'CSV',
                        title: export_title,
                        className: 'btn btn-brand',
                        exportOptions: {
                            columns: ':visible'
                        }
                    },
                    {
                        extend: 'excel',
                        text: 'Excel',
                        title: export_title,
                        className: 'btn btn-brand',
                        exportOptions: {
                            columns: ':visible'
                        }
                    },
                    {
                        extend: 'print',
                        text: this.$t("general." + "Print"),
                        title: export_title,
                        className: 'btn btn-brand',
                        exportOptions: {
                            columns: ':visible'
                        }
                    },
                ]
            });

            if(this.data.pressure){

                this.table[1] = $('#basicTable_press').DataTable({
                    language: {
                        url: '/assets/i18n/' + this.user.language + '.json'
                    },
                    order: [[0, "desc"]],
                    dom: '<"row"<"col-sm-6"B><"col-sm-6">>t<"row"<"col-sm-6"i><"col-sm-6"p>><"clear">',
                    ordering: true,
                    pageLength: 10,
                    responsive: true,
                    buttons: [
                        {
                            extend: 'csv',
                            text: 'CSV',
                            title: export_title,
                            className: 'btn btn-brand',
                            exportOptions: {
                                columns: ':visible'
                            }
                        },
                        {
                            extend: 'excel',
                            text: 'Excel',
                            title: export_title,
                            className: 'btn btn-brand',
                            exportOptions: {
                                columns: ':visible'
                            }
                        },
                        {
                            extend: 'print',
                            text: this.$t("general." + "Print"),
                            title: export_title,
                            className: 'btn btn-brand',
                            exportOptions: {
                                columns: ':visible'
                            }
                        },
                    ]
                });

            }
        }

        if(this.register_length != 0){

            for (var i = 0; i < this.register_length; i++) { //this.user.timezone_offset
                this.datehour[i] = this.data.pulse[2][this.register_length - i - 1].date.substring(11, 16);
                this.dateday[i] = this.data.pulse[2][this.register_length - i - 1].date.substring(0, 10);

                this.xdate[i] = new Date((this.data.pulse[2][this.register_length - i - 1].date + ' GMT')).getTime();
                this.intervalConsumption24h_15[i] = [this.xdate[i], parseFloat(this.data.pulse[2][this.register_length - i - 1].values.consumption.toFixed(3))];
                this.flowperHour24h_15[i] = [this.xdate[i], parseFloat(this.data.pulse[2][this.register_length - i - 1].values.flow.toFixed(3))];
            };

            this.consumptionMin = this.intervalConsumption24h_15[0][1];
            this.consumptionMax = this.intervalConsumption24h_15[0][1];
            this.totalconsumption = 0;

            this.flowMin = this.flowperHour24h_15[0][1];
            this.flowMax = this.flowperHour24h_15[0][1];
            this.totalflow = 0;

            for (var i = 0; i < this.intervalConsumption24h_15.length; i++) {
                if (this.consumptionMin > this.intervalConsumption24h_15[i][1]) {
                    this.consumptionMin = this.intervalConsumption24h_15[i][1];
                }
                if (this.consumptionMax < this.intervalConsumption24h_15[i][1]) {
                    this.consumptionMax = this.intervalConsumption24h_15[i][1];
                }
                this.totalconsumption += this.intervalConsumption24h_15[i][1];


                if (this.flowMin > this.flowperHour24h_15[i][1]) {
                    this.flowMin = this.flowperHour24h_15[i][1];
                }
                if (this.flowMax < this.flowperHour24h_15[i][1]) {
                    this.flowMax = this.flowperHour24h_15[i][1];
                }
                this.totalflow += this.flowperHour24h_15[i][1];
            }

            this.consumptionAvg = this.totalconsumption / this.intervalConsumption24h_15.length;
            this.flowAvg = this.totalflow / this.flowperHour24h_15.length;
        }

        this.centralChart = {
            chart: {
                zoomType: 'x',
                backgroundColor: 'transparent',
                spacingTop: 20,
                animation: {
                    duration: 150
                },
                resetZoomButton: {
                    position: {
                        align: 'left',
                        verticalAlign: 'top',
                        x: 0,
                        y: 2.5,
                    },
                    theme: {
                        r: 5.6,
                    }
                }
            },
            accessibility: {
                enabled: false
            },
            title: {
                text: ''
            },
            xAxis: {
                lineColor: '#647F8C',
                //tickInterval: 5,
                //categories: this.xdate,
                visible: true,
                labels: {
                    style: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.7,
                    }
                },
                type: "datetime",
                dateTimeLabelFormats: {
                    //  millisecond: '%H:%M:%S.%L',
                    //second: '%H:%M:%S',
                    //minute: '%H:%M',
                    hour: '%H:%M',
                    day: '%m-%d',
                    week: '%m-%d',
                    month: '%Y-%m',
                    year: '%Y'
                }
            },
            yAxis: [{
                gridLineColor: '#647F8C',
                id: 0,
                opposite: true,
                title: {
                    text: ''
                },
                labels: {
                    formatter: function () {
                        return this.pos + '  ' + this.chart.userOptions.series[0].tooltip.valueSuffix
                    },
                    style: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.7,
                    }
                },
                visible: true, //(this.screen_width >= 768) ? true : false ,
                //startOnTick: false,
                //endOnTick: false                  
            }, {
                gridLineColor: '#647F8C',
                id: 1,
                title: {
                    text: ''
                },
                labels: {
                    formatter: function () {
                        return this.pos + '  ' + this.chart.userOptions.series[1].tooltip.valueSuffix
                    },
                    style: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.7,
                    }
                },
                visible: true, //(this.screen_width >= 768) ? true : false ,
                //startOnTick: false,
                //endOnTick: false               
            }],
            exporting: {
                enabled: false
            },
            credits: {
                enabled: false
            },
            legend: {
                enabled: true,
                itemStyle: {
                    color: 'rgba(200, 200, 200, 0.9)',
                    opacity: 0.75,
                    fontWeight: 'light'
                },
                itemHoverStyle: {
                    color: 'rgba(200, 200, 200, 0.9)',
                    opacity: 1,
                    fontWeight: 'light'
                }
            },
            /*tooltip: {
            formatter: function() {
                return Highcharts.dateFormat('%Y-%m-%d  %H:%M:%S', this.x) + ' -> ' + this.y.toFixed(3) + ' ' + this.series.tooltipOptions.valueSuffix;
            },
         
            style: {
                color: 'rgba(200, 200, 200, 0.9)',
            },   
            headerFormat: '',
            borderColor: 'rgba(0,57,93,0)',
            backgroundColor: 'rgba(0,57,93,0)',    
            shadow: false,   
            }*/
            /*tooltip: {
                //headerFormat: '<p style="font-size:12px; line-height: 12px; color:#b8bec0">{point.key} </p><br/>',
                //xDateFormat: '%Y-%m-%d  %H:%M:%S',
                shared: true,
                split: false,
                backgroundColor: '#075267',
                borderRadius: 12,
                borderWidth: 0,
                outside:true,
                formatter: function () {
                        var s = '<b>' + '<p style="font-size:12px; line-height: 12px; color:#b8bec0">' + Highcharts.dateFormat('%Y-%m-%d  %H:%M:%S', this.x) +'</p>';
                        $.each(this.points, function () {
                            s += '<br/><p style="color:'+this.series.color+'">' + this.series.name + ': <p><p style="color:#b8bec0"">' + this.y +
                            ' ' + this.series.userOptions.tooltip.valueSuffix + '<p><br/>';
                        });

                    
                    return s;
                }, 
            },   */
            tooltip: {
                //headerFormat: '<p style="font-size:12px; line-height: 12px; color:#b8bec0">{point.key} </p><br/>',
                //xDateFormat: '%Y-%m-%d  %H:%M:%S',
                shared: true,
                split: false,
                backgroundColor: 'rgba(7,82,103,0.95)',
                borderRadius: 12,
                borderWidth: 1,
                borderColor: 'rgba(250, 250, 250, 0.65)',
                padding: 6,
                formatter: function () {

                    var date = new Date(this.x - user.timezone_offset * 1000 * 60 * 60);

                    var day = date.getDate();
                    var month = date.getMonth() + 1;
                    var year = date.getFullYear();
                    var hour = date.getHours();
                    var min = date.getMinutes();

                    if (month.toString().length == 1) month = '0' + month;
                    if (day.toString().length == 1) day = '0' + day;
                    if (hour.toString().length == 1) hour = '0' + hour;
                    if (min.toString().length == 1) min = '0' + min;

                    var tempx = `${year}/${month}/${day} ${hour}:${min}`;
                    var s = '<b>' + '<p style="font-size:12px; line-height: 12px; font-weight: 300; color:rgba(250, 250, 250, 0.95)">' + tempx + '</p><br/>';
                    $.each(this.points, function () {
                        s += '<p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.series.name + ' </p><p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.y.toFixed(3) +
                            ' ' + this.series.userOptions.tooltip.valueSuffix + '</p><br/>';
                    });


                    return s;
                },
            },
        };

        /*this.centralChart.tooltip.positioner = function(labelWidth, _, point) {
            return {
                x: point.plotX,
                y: -5, 
            };
        };*/

        /*if(this.night_start<this.night_end){
            this.centralChart.xAxis.plotBands = 
                [{
                    from: this.night_start,
                    to: this.night_end,
                    color: 'rgba(25,25,25,0.50)',
                }]
        }else{
            this.centralChart.xAxis.plotBands = 
                [{
                    from: 0,
                    to: this.night_end,
                    color: 'rgba(25,25,25,0.50)',
                },{
                    from: this.night_start,
                    to: this.datehour.length -1,
                    color: 'rgba(25,25,25,0.50)',
                }]
        }*/

        this.centralChart.series = [{
            name: this.$t("water." + "consumptionLang"),
            type: 'areaspline',
            yAxis: 0,
            data: this.intervalConsumption24h_15,
            color: "#05fff3",
            lineWidth: 0,
            opacity: 0.8,
            marker: {
                enabled: false
            },
            tooltip: {
                valueSuffix: 'm³'
            }
        }, {
            name: this.$t("water." + "flowLang"),
            type: 'spline',
            visible: true,
            yAxis: 1,
            data: this.flowperHour24h_15,
            color: "#FF29D9",// 6DFF33
            lineWidth: 1.5,
            marker: {
                enabled: false
            },
            tooltip: {
                valueSuffix: 'm³/h'
            }
        }];

        this.Highcharts.chart('flowchart', this.centralChart); // Setting flowchart

        if (this.data.pressure) {
            for (var i = 0; i < this.data.pressure.length; i++) {
                this.pressuredata24h_15_avg[i] = [this.xdate[i], parseFloat(this.data.pressure[this.data.pressure.length - 1 - i].values.avg)];
                this.pressuredata24h_15_min[i] = [this.xdate[i], parseFloat(this.data.pressure[this.data.pressure.length - 1 - i].values.min)];
                this.pressuredata24h_15_max[i] = [this.xdate[i], parseFloat(this.data.pressure[this.data.pressure.length - 1 - i].values.max)];
            };

            this.pressureMin = this.pressuredata24h_15_min[0][1];
            this.pressureMax = this.pressuredata24h_15_max[0][1];
            this.sumpressure = 0;

            var order_pressure = new Array(this.pressuredata24h_15_avg.length);
            var order_amplitud = new Array(this.pressuredata24h_15_avg.length);
            this.amplitud = new Array(this.pressuredata24h_15_avg.length);

            for (var i = 0; i < this.pressuredata24h_15_avg.length; i++) {
                order_pressure[i] = this.pressuredata24h_15_avg[i][1];
                this.amplitud[i] = parseFloat(this.pressuredata24h_15_max[i][1] - this.pressuredata24h_15_min[i][1]).toFixed(3);
                order_amplitud[i] = this.amplitud[i];
            }

            order_pressure.sort(function (a, b) { return a - b; });
            order_amplitud.sort(function (a, b) { return a - b; });

            this.Q1 = order_pressure[parseInt(order_pressure.length / 4)];
            this.Q2 = order_pressure[parseInt(order_pressure.length / 2)];
            this.Q3 = order_pressure[parseInt(order_pressure.length * 3 / 4)];
            this.maxAmp = parseFloat(order_amplitud[parseInt(order_amplitud.length) - 1] - order_amplitud[0]).toFixed(3);

            for (var i = 0; i < this.pressuredata24h_15_avg.length; i++) {
                if (this.pressureMin > this.pressuredata24h_15_min[i][1]) {
                    this.pressureMin = this.pressuredata24h_15_min[i][1];
                }
                if (this.pressureMax < this.pressuredata24h_15_max[i][1]) {
                    this.pressureMax = this.pressuredata24h_15_max[i][1];
                }
                this.sumpressure += this.pressuredata24h_15_avg[i][1];
            }

            this.pressureAvg = this.sumpressure / this.pressuredata24h_15_avg.length;

            this.topChart = {
                chart: {
                    zoomType: 'x',
                    backgroundColor: 'transparent',
                    spacingTop: 20,
                    animation: {
                        duration: 150
                    },
                    resetZoomButton: {
                        position: {
                            align: 'left',
                            verticalAlign: 'top',
                            x: 0,
                            y: 2.5
                        },
                        theme: {
                            r: 5.6,
                        }
                    }
                },
                accessibility: {
                    enabled: false
                },
                title: {
                    text: ''
                },
                xAxis: {
                    lineColor: '#647F8C',
                    //tickInterval: 5,
                    //categories: this.xdate,
                    visible: true,
                    labels: {
                        style: {
                            color: 'rgba(200, 200, 200, 0.9)',
                            opacity: 0.7,
                        }
                    },
                    type: "datetime",
                    dateTimeLabelFormats: {
                        //  millisecond: '%H:%M:%S.%L',
                        //second: '%H:%M:%S',
                        //minute: '%H:%M',
                        hour: '%H:%M',
                        day: '%m-%d',
                        week: '%m-%d',
                        month: '%Y-%m',
                        year: '%Y'
                    }
                },
                yAxis: [{
                    gridLineColor: '#647F8C',
                    //opposite: true,
                    title: {
                        text: ''
                    },
                    labels: {
                        formatter: function () {
                            return this.pos + ' bar'
                        },
                        style: {
                            color: 'rgba(200, 200, 200, 0.9)',
                            opacity: 0.7,
                        }
                    },
                    visible: true, //(this.screen_width >= 768) ? true : false ,
                    //startOnTick: false,
                    //endOnTick: false                   
                }],
                exporting: {
                    enabled: false
                },
                credits: {
                    enabled: false
                },
                legend: {
                    enabled: true,
                    itemStyle: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 0.75,
                        fontWeight: 'light'
                    },
                    itemHoverStyle: {
                        color: 'rgba(200, 200, 200, 0.9)',
                        opacity: 1,
                        fontWeight: 'light'
                    }
                },
                /*tooltip: {
                formatter: function() {
                    return Highcharts.dateFormat('%Y-%m-%d  %H:%M:%S', this.x) + ' -> ' + this.y.toFixed(3) + ' ' + this.series.tooltipOptions.valueSuffix;
                },
                style: {
                    color: 'rgba(200, 200, 200, 0.9)',
                },   
                headerFormat: '',
                borderColor: 'rgba(0,57,93,0)',
                backgroundColor: 'rgba(0,57,93,0)',    
                shadow: false,   
                }*/
                /*tooltip: {
                    //headerFormat: '<p style="font-size:12px; line-height: 12px; color:#b8bec0">{point.key} </p><br/>',
                    //xDateFormat: '%Y-%m-%d  %H:%M:%S',
                    shared: true,
                    split: false,
                    backgroundColor: '#075267',
                    borderRadius: 12,
                    borderWidth: 0,
                    outside:true,
                    formatter: function () {
                            var s = '<b>' + '<p style="font-size:12px; line-height: 12px; color:#b8bec0">' + Highcharts.dateFormat('%Y-%m-%d  %H:%M:%S', this.x) +'</p>';
                            $.each(this.points, function () {
                                s += '<br/><p style="color:'+this.series.color+'">' + this.series.name + ': <p><p style="color:#b8bec0"">' + this.y +
                                ' bar<p><br/>';
                            });

                        
                        return s;
                    }, 
                },  */

                tooltip: {
                    //headerFormat: '<p style="font-size:12px; line-height: 12px; color:#b8bec0">{point.key} </p><br/>',
                    //xDateFormat: '%Y-%m-%d  %H:%M:%S',
                    valueSuffix: ' bar',
                    shared: true,
                    split: false,
                    backgroundColor: 'rgba(7,82,103,0.95)',
                    borderRadius: 12,
                    borderWidth: 1,
                    borderColor: 'rgba(250, 250, 250, 0.65)',
                    padding: 6,
                    formatter: function () {

                        var date = new Date(this.x - user.timezone_offset * 1000 * 60 * 60);

                        var day = date.getDate();
                        var month = date.getMonth() + 1;
                        var year = date.getFullYear();
                        var hour = date.getHours();
                        var min = date.getMinutes();

                        if (month.toString().length == 1) month = '0' + month;
                        if (day.toString().length == 1) day = '0' + day;
                        if (hour.toString().length == 1) hour = '0' + hour;
                        if (min.toString().length == 1) min = '0' + min;

                        var tempx = `${year}/${month}/${day} ${hour}:${min}`;
                        var s = '<b>' + '<p style="font-size:12px; line-height: 12px; font-weight: 300; color:rgba(250, 250, 250, 0.95)">' + tempx + '</p><br/>';
                        $.each(this.points, function () {
                            s += '<p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.series.name + ' </p><p style="font-size:12px; line-height: 12px; font-weight: 400; color:' + this.series.color + '">' + this.y.toFixed(3) +
                                ' bar' + '</p><br/>';
                        });

                        return s;
                    },
                },
            };

            //this.topChart.tooltip.valueSuffix = 'bar';

            /*this.topChart.tooltip.positioner = function(labelWidth, _, point) {
                return {
                    x: point.plotX,
                    y: -5, 
                };
                };*/

            /*if(this.night_start<this.night_end){
                this.topChart.xAxis.plotBands = 
                    [{
                        from: this.night_start,
                        to: this.night_end,
                        color: 'rgba(25,25,25,0.50)',
                    }]
            }else{
                this.topChart.xAxis.plotBands = 
                    [{
                        from: 0,
                        to: this.night_end,
                        color: 'rgba(25,25,25,0.50)',
                    },{
                        from: this.night_start,
                        to: this.datehour.length -1,
                        color: 'rgba(25,25,25,0.50)',
                    }]
            }
            */

            this.topChart.series = [{
                name: this.$t("general." + "Max"),
                type: 'spline',
                data: this.pressuredata24h_15_max,
                color: "#FFC100",
                lineWidth: 1.5,
                marker: {
                    enabled: false,
                },
                tooltip: {
                    valueSuffix: 'bar'
                }
            }, {
                name: this.$t("general." + "Avg"),
                type: 'spline',
                data: this.pressuredata24h_15_avg,
                color: "#6DFF33",
                lineWidth: 1.5,
                marker: {
                    enabled: false,
                },
                tooltip: {
                    valueSuffix: 'bar'
                }
            }, {
                name: this.$t("general." + "Min"),
                type: 'spline',
                data: this.pressuredata24h_15_min,
                color: "#05fff3",
                lineWidth: 1.5,
                marker: {
                    enabled: false,
                },
                tooltip: {
                    valueSuffix: 'bar'
                }
            }];

            //this.topChart = this.topChart;

            this.Highcharts.chart('pressurechart', this.topChart); // Setting mAMpressurechart

        };

        if(this.screen_width >= 768){

            this.table.clear();
            if (this.data.pressure) {
                for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                    this.table.row.add([
                        '<td>' + this.dateday[this.datehour.length - (index + 1)] + ' ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                        '<td>' + this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                        '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                        '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                        '<td>' + this.pressuredata24h_15_min[this.pressuredata24h_15_min.length - 1 - index][1] + '</td>',
                        '<td>' + this.pressuredata24h_15_avg[this.pressuredata24h_15_avg.length - 1 - index][1] + '</td>',
                        '<td>' + this.pressuredata24h_15_max[this.pressuredata24h_15_max.length - 1 - index][1] + '</td>',
                        '<td>' + this.amplitud[this.amplitud.length - 1 - index] + '</td>',
                    ]).draw(false);
                };
            } else if(this.register_length != 0){
                for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                    this.table.row.add([
                        '<td>' + this.dateday[this.datehour.length - (index + 1)] + ' ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                        '<td>' + this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                        '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                        '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                    ]).draw(false);
                };
            }
        }else{

            if (this.data.pressure) {
                this.table[1].clear();
                for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                    this.table[1].row.add([
                        '<td>' + this.dateday[this.datehour.length - (index + 1)].substring(5) + ' ' +  this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                        '<td>' + this.pressuredata24h_15_min[this.pressuredata24h_15_min.length - 1 - index][1] + '</td>',
                        '<td>' + this.pressuredata24h_15_avg[this.pressuredata24h_15_avg.length - 1 - index][1] + '</td>',
                        '<td>' + this.pressuredata24h_15_max[this.pressuredata24h_15_max.length - 1 - index][1] + '</td>',
                    ]).draw(false);

                    this.table[0].row.add([
                        '<td>' + this.dateday[this.datehour.length - (index + 1)].substring(5) + ' ' +  this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                        '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                        '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                    ]).draw(false);
                };
            } else if(this.register_length != 0){
                this.table[0].clear();
                for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                    this.table[0].row.add([
                        '<td>' + this.dateday[this.datehour.length - (index + 1)].substring(5) + ' ' +  this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                        '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                        '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                    ]).draw(false);
                };
            }

        }


        if(this.register_length != 0){
            this.end_date = new Date(this.data.pulse[2][0].date);
            this.start_date = new Date(this.data.pulse[2][this.register_length - 1].date);
        }else{
            this.end_date = new Date();
            this.end_date.setDate(this.end_date.getDate() - 1);
            this.start_date = new Date();
        }

        this.date = [this.start_date, this.end_date];
    },

    methods: {


        getRandomInt(min, max) {
            return Math.floor(Math.random() * (max - min)) + min;
        },
        format() {
            var date = this.date;
            var to = this.$t("general." + "To")

            var day1 = date[0].getDate();
            var month1 = date[0].getMonth() + 1;
            var year1 = date[0].getFullYear();
            var hour1 = date[0].getHours();
            var min1 = date[0].getMinutes();

            if (month1.toString().length == 1) month1 = '0' + month1;
            if (day1.toString().length == 1) day1 = '0' + day1;
            if (hour1.toString().length == 1) hour1 = '0' + hour1;
            if (min1.toString().length == 1) min1 = '0' + min1;

            var day2 = date[1].getDate();
            var month2 = date[1].getMonth() + 1;
            var year2 = date[1].getFullYear();
            var hour2 = date[1].getHours();
            var min2 = date[1].getMinutes();

            if (month2.toString().length == 1) month2 = '0' + month2;
            if (day2.toString().length == 1) day2 = '0' + day2;
            if (hour2.toString().length == 1) hour2 = '0' + hour2;
            if (min2.toString().length == 1) min2 = '0' + min2;

            return `${year1}/${month1}/${day1} ${hour1}:${min1} ${to} ${year2}/${month2}/${day2} ${hour2}:${min2}`;
        },
        epoch_format(timestamp) {

            var date = new Date(timestamp * 1000);

            var day = date.getDate();
            var month = date.getMonth() + 1;
            var year = date.getFullYear();
            var hour = date.getHours();
            var min = date.getMinutes();

            if (month.toString().length == 1) month = '0' + month;
            if (day.toString().length == 1) day = '0' + day;
            if (hour.toString().length == 1) hour = '0' + hour;
            if (min.toString().length == 1) min = '0' + min;

            return `${year}/${month}/${day} ${hour}:${min}`;
        },
        update(modelData) {

            /*var end_date = document.getElementById("end_date").value;
            var start_date = document.getElementById("start_date").value;*/

            if(this.screen_width >= 768){
                this.table.clear();
            }else{
                if(this.data.pressure){
                    this.table[1].clear();
                }
                this.table[0].clear();
            }

            if( modelData[0].getFullYear() === modelData[1].getFullYear() &&
                modelData[0].getMonth() === modelData[1].getMonth() &&
                modelData[0].getDate() === modelData[1].getDate()){
                    
                modelData[0].setHours(0);
                modelData[0].setMinutes(0);
                modelData[0].setSeconds(0);

                modelData[1].setHours(23);
                modelData[1].setMinutes(59);
                modelData[1].setSeconds(59);
            }

            var start_date = new Date((modelData[0]));
            start_date = start_date.getTime() - this.user.timezone_offset * 1000 * 60 * 60;


            var end_date = new Date((modelData[1]));
            end_date = end_date.getTime() - this.user.timezone_offset * 1000 * 60 * 60;

            if (start_date > new Date()) {
                start_date = new Date();
                start_date.setDate(start_date.getDate());
            }

            if (end_date > new Date()) {
                end_date = new Date();
            }

            this.getLastDayFlow(end_date, start_date).then(response => {

                var datehour = new Array(response.data.pulse[2].length);
                var dateday = new Array(response.data.pulse[2].length);
                var xdate = new Array(response.data.pulse[2].length);
                var intervalConsumption24h_15 = new Array(response.data.pulse[2].length);
                var flowperHour24h_15 = new Array(response.data.pulse[2].length);

                for (var i = 0; i < response.data.pulse[2].length; i++) {
                    datehour[i] = response.data.pulse[2][response.data.pulse[2].length - i - 1].date.substring(11, 16);
                    dateday[i] = response.data.pulse[2][response.data.pulse[2].length - i - 1].date.substring(0, 10);
                    xdate[i] = ((new Date((response.data.pulse[2][response.data.pulse[2].length - i - 1].date + ' GMT')).getTime()));//- (new Date().getTimezoneOffset() * 60 * 1000));//1000;

                    intervalConsumption24h_15[i] = [xdate[i], parseFloat(response.data.pulse[2][response.data.pulse[2].length - i - 1].values.consumption.toFixed(3))];
                    flowperHour24h_15[i] = [xdate[i], parseFloat(response.data.pulse[2][response.data.pulse[2].length - i - 1].values.flow.toFixed(3))];
                };

                this.consumptionMin = intervalConsumption24h_15[0][1];
                this.consumptionMax = intervalConsumption24h_15[0][1];
                this.totalconsumption = 0;

                this.flowMin = flowperHour24h_15[0][1];
                this.flowMax = flowperHour24h_15[0][1];
                this.totalflow = 0;

                for (var i = 0; i < intervalConsumption24h_15.length; i++) {
                    if (this.consumptionMin > intervalConsumption24h_15[i][1]) {
                        this.consumptionMin = intervalConsumption24h_15[i][1];
                    }
                    if (this.consumptionMax < intervalConsumption24h_15[i][1]) {
                        this.consumptionMax = intervalConsumption24h_15[i][1];
                    }
                    this.totalconsumption += intervalConsumption24h_15[i][1];


                    if (this.flowMin > flowperHour24h_15[i][1]) {
                        this.flowMin = flowperHour24h_15[i][1];
                    }
                    if (this.flowMax < flowperHour24h_15[i][1]) {
                        this.flowMax = flowperHour24h_15[i][1];
                    }
                    this.totalflow += flowperHour24h_15[i][1];
                }

                this.consumptionAvg = this.totalconsumption / intervalConsumption24h_15.length;
                this.flowAvg = this.totalflow / flowperHour24h_15.length;

                this.centralChart.series = [{
                    name: this.$t("water." + "consumptionLang"),
                    type: 'areaspline',
                    yAxis: 0,
                    data: intervalConsumption24h_15,
                    color: "#05fff3",
                    lineWidth: 0,
                    opacity: 0.8,
                    marker: {
                        enabled: false
                    },
                    tooltip: {
                        valueSuffix: 'm³'
                    }
                }, {
                    name: this.$t("water." + "flowLang"),
                    type: 'spline',
                    visible: true,
                    yAxis: 1,
                    data: flowperHour24h_15,
                    color: "#FF29D9",// 6DFF33
                    lineWidth: 1.5,
                    marker: {
                        enabled: false
                    },
                    tooltip: {
                        valueSuffix: 'm³/h'
                    }
                }];

                //this.centralChart.xAxis.categories = xdate;
                this.datehour = datehour;
                this.dateday = dateday;
                this.flowperHour24h_15 = flowperHour24h_15;
                this.intervalConsumption24h_15 = intervalConsumption24h_15;
                this.Highcharts.chart('flowchart', this.centralChart); // Setting flowchart

                if (response.data.pressure) {
                    var pressuredata24h_15_avg = new Array(response.data.pressure.length);
                    var pressuredata24h_15_min = new Array(response.data.pressure.length);
                    var pressuredata24h_15_max = new Array(response.data.pressure.length);

                    for (var i = 0; i < response.data.pressure.length; i++) {
                        pressuredata24h_15_avg[i] = [xdate[i], parseFloat(response.data.pressure[response.data.pressure.length - i - 1].values.avg)];
                        pressuredata24h_15_min[i] = [xdate[i], parseFloat(response.data.pressure[response.data.pressure.length - i - 1].values.min)];
                        pressuredata24h_15_max[i] = [xdate[i], parseFloat(response.data.pressure[response.data.pressure.length - i - 1].values.max)];
                    };


                    this.pressureMin = pressuredata24h_15_min[0][1];
                    this.pressureMax = pressuredata24h_15_max[0][1];
                    this.sumpressure = 0;

                    var order_pressure = new Array(this.pressuredata24h_15_avg.length);
                    var order_amplitud = new Array(this.pressuredata24h_15_avg.length);
                    var amplitud = new Array(this.pressuredata24h_15_avg.length);

                    for (var i = 0; i < this.pressuredata24h_15_avg.length; i++) {
                        order_pressure[i] = this.pressuredata24h_15_avg[i][1];
                        amplitud[i] = parseFloat(this.pressuredata24h_15_max[i][1] - this.pressuredata24h_15_min[i][1]).toFixed(3);
                        order_amplitud[i] = amplitud[i];
                    }

                    order_pressure.sort(function (a, b) { return a - b; });
                    order_amplitud.sort(function (a, b) { return a - b; });

                    this.Q1 = order_pressure[parseInt(order_pressure.length / 4)];
                    this.Q2 = order_pressure[parseInt(order_pressure.length / 2)];
                    this.Q3 = order_pressure[parseInt(order_pressure.length * 3 / 4)];
                    this.maxAmp = parseFloat(order_amplitud[parseInt(order_amplitud.length) - 1] - order_amplitud[0]).toFixed(3);

                    for (var i = 0; i < pressuredata24h_15_avg.length; i++) {
                        if (this.pressureMin > pressuredata24h_15_min[i][1]) {
                            this.pressureMin = pressuredata24h_15_min[i][1];
                        }
                        if (this.pressureMax < pressuredata24h_15_max[i][1]) {
                            this.pressureMax = pressuredata24h_15_max[i][1];
                        }
                        this.sumpressure += pressuredata24h_15_avg[i][1];
                    }

                    this.pressureAvg = this.sumpressure / pressuredata24h_15_avg.length;

                    this.topChart.series = [{
                        name: this.$t("general." + "Max"),
                        type: 'spline',
                        data: pressuredata24h_15_max,
                        color: "#FFC100",
                        lineWidth: 1.5,
                        marker: {
                            enabled: false,
                            tooltip: {
                                valueSuffix: 'bar'
                            }
                        },
                    }, {
                        name: this.$t("general." + "Avg"),
                        type: 'spline',
                        data: pressuredata24h_15_avg,
                        color: "#6DFF33",
                        lineWidth: 1.5,
                        marker: {
                            enabled: false,
                            tooltip: {
                                valueSuffix: 'bar'
                            }
                        },
                    }, {
                        name: this.$t("general." + "Min"),
                        type: 'spline',
                        data: pressuredata24h_15_min,
                        color: "#05fff3",
                        lineWidth: 1.5,
                        marker: {
                            enabled: false,
                            tooltip: {
                                valueSuffix: 'bar'
                            }
                        },
                    }];

                    //this.topChart.xAxis.categories = xdate;
                    this.datehour = datehour;
                    this.dateday = dateday;
                    this.pressuredata24h_15_avg = pressuredata24h_15_avg;
                    this.pressuredata24h_15_max = pressuredata24h_15_max;
                    this.pressuredata24h_15_min = pressuredata24h_15_min;
                    this.amplitud = amplitud;
                    this.Highcharts.chart('pressurechart', this.topChart); // Setting mAMpressurechart

                    if(this.screen_width >= 768){
                        this.table.clear();
                    }else{
                        if(this.data.pressure){
                            this.table[1].clear();
                        }
                        this.table[0].clear();
                    }

                    if(this.screen_width >= 768){

                        for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                            this.table.row.add([
                                '<td>' + this.dateday[this.datehour.length - (index + 1)] + ' ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                                '<td>' + this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                                '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                                '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                                '<td>' + this.pressuredata24h_15_min[this.pressuredata24h_15_min.length - 1 - index][1] + '</td>',
                                '<td>' + this.pressuredata24h_15_avg[this.pressuredata24h_15_avg.length - 1 - index][1] + '</td>',
                                '<td>' + this.pressuredata24h_15_max[this.pressuredata24h_15_max.length - 1 - index][1] + '</td>',
                                '<td>' + this.amplitud[this.amplitud.length - 1 - index] + '</td>',
                            ]).draw(false);
                        };

                    }else{

                        for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                            this.table[0].row.add([
                                '<td>' + this.dateday[this.datehour.length - (index + 1)].substring(5) + ' ' +  this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                                '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                                '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                            ]).draw(false);

                            this.table[1].row.add([
                                '<td>' + this.dateday[this.datehour.length - (index + 1)].substring(5) + ' ' +  this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                                '<td>' + this.pressuredata24h_15_min[this.pressuredata24h_15_min.length - 1 - index][1] + '</td>',
                                '<td>' + this.pressuredata24h_15_avg[this.pressuredata24h_15_avg.length - 1 - index][1] + '</td>',
                                '<td>' + this.pressuredata24h_15_max[this.pressuredata24h_15_max.length - 1 - index][1] + '</td>',
                            ]).draw(false);

                        };
                    }

                    
                } else {

                    if(this.screen_width >= 768){
                        this.table.clear();
                    }else{
                        if(this.data.pressure){
                            this.table[1].clear();
                        }
                        this.table[0].clear();
                    }

                    if(this.screen_width >= 768){

                        for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                            this.table.row.add([
                                '<td>' + this.dateday[this.datehour.length - (index + 1)] + ' ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                                '<td>' + this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                                '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                                '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                            ]).draw(false);
                        };

                    }else{

                        for (var index = 0; index < this.intervalConsumption24h_15.length; index++) {
                            this.table[0].row.add([
                                '<td>' + this.dateday[this.datehour.length - (index + 1)].substring(5) + ' ' +  this.datehour[this.datehour.length - (index + 2)] + ' - ' + this.datehour[this.datehour.length - (index + 1)] + '</td>',
                                '<td>' + this.intervalConsumption24h_15[this.intervalConsumption24h_15.length - 1 - index][1] + '</td>',
                                '<td>' + this.flowperHour24h_15[this.flowperHour24h_15.length - 1 - index][1] + '</td>',
                            ]).draw(false);
                        };

                    }
                };
            })

            var end_event = new Date(end_date);

            end_event = new Date(end_event.getTime() + this.user.timezone_offset * 1000 * 60 * 60 + new Date().getTimezoneOffset() * 60 * 1000);

            end_event.setDate(end_event.getDate());
            end_event.setMonth(end_event.getMonth());
            end_event.setHours(end_event.getHours());

            var MM = end_event.getMonth() + 1;
            var dd = end_event.getDate();
            var hh = end_event.getHours();
            var mm = end_event.getMinutes();
            var ss = end_event.getSeconds();

            if (MM.toString().length == 1) MM = '0' + MM;
            if (dd.toString().length == 1) dd = '0' + dd;
            if (hh.toString().length == 1) hh = '0' + hh;
            if (mm.toString().length == 1) mm = '0' + mm;
            if (ss.toString().length == 1) ss = '0' + ss;

            end_date = end_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

            var start_event = new Date(start_date);

            start_event = new Date(start_event.getTime() + this.user.timezone_offset * 1000 * 60 * 60 + new Date().getTimezoneOffset() * 60 * 1000);

            start_event.setDate(start_event.getDate());
            start_event.setMonth(start_event.getMonth());
            start_event.setHours(start_event.getHours());

            var MM = start_event.getMonth() + 1;
            var dd = start_event.getDate();
            var hh = start_event.getHours();
            var mm = start_event.getMinutes();
            var ss = start_event.getSeconds();

            if (MM.toString().length == 1) MM = '0' + MM;
            if (dd.toString().length == 1) dd = '0' + dd;
            if (hh.toString().length == 1) hh = '0' + hh;
            if (mm.toString().length == 1) mm = '0' + mm;
            if (ss.toString().length == 1) ss = '0' + ss;

            start_date = start_event.getFullYear() + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;

            const startDate = new Date(start_date + ' GMT');
            const endDate = new Date(end_date + ' GMT');

            this.end_date = endDate;
            this.start_date = startDate;

            this.date = [startDate, endDate];
        },
    },
}    
</script>

